/*
** ===================================================================
** Nzev souboru   : servo.c
** Mikrokontroler  : ATmega16
** Popis           : Funkce pro ovldn modelskho serva
**
** Autor           : Radek Balada ( xbalad01@stud.feec.vutbr.cz )
** Pedmt         : Mikropocitace pro pristrojove aplikace
** Posledn zmna  : 29.08.06 15:05
** ===================================================================
*/

/* Frekvence krystalu */
#define F_CPU 16000000		//definice frekvence procesoru


/*
** Hlavikov soubory
*/
#include <stdio.h> 		// definin soubor pro mikrokontrolr ATmega16
#include ".\avr\interrupt.h" //definicni soubor pro obsluhu preruseni
#include <util/delay.h>		//definicni soubor pro zpozdeni
#include "lcd_h.h"			//definicni soubor pro ovladani displeje
#include "servo_h.h" 		//definicni soubor pro ovladani serva


/*
** Globln promnn
*/
char string[16];
char timer2 = 10;
char maximum = 0b11111010;
char minimum = 0b00000001;
char neutral = 0b01111100;
char poloha = 0b01111100;
char smer = 0;
//char output =0;


	
/*
** ===================================================================
**     Nzev funkce  : main()
**
**     Popis         :
**         Inicializace mikrokontroleru, vypsani textu na LCD displej,
**		   nastaveni stredove polohy serva
**     Parametry     : dn
**     Vst. hodnota : dn
** ===================================================================
*/
int main()
{
poloha=neutral;
servo_init(poloha) ;		//inicialicace nastaveni pro rizeni serva

servo_poloha(maximum, 0);	//zmena polohy serva 0
servo_poloha(neutral, 5);	//zmena polohy serva 5
servo_poloha(minimum, 7);	//zmena polohy serva 7


// Vypis textu na displej
lcd_init();					//inicializace displeje 
lcd_clrscr();				//smazani displeje
lcd_gotoxy(0,0);			//nastaveni kurzoru na pozici x, y
lcd_puts("Rizeni serva v3");//vypsani textu na LCD
lcd_gotoxy(0,1);			//nastaveni kurzoru na pozici x, y
sprintf(string,"poloha3=%u",poloha);
lcd_puts(string);			//vypsani textu na LCD

//lcd_clrscr();


sei();				//globalni povoleni preruseni

while(1)			//nekonecna smycka
	{
	
//	_delay_ms( 10 ) ;		//zpodn [ms]
	timer2++;
	// zmena polohy serva
	if (timer2==50)
	{
	timer2=255;
	switch (smer)
		{
		case 0:
			{
			//poloha=200;
			//smer = 1;
			poloha--;
			if (poloha==minimum) smer = 1;	//zmena smeru pohybu serva
			break;
			}
		case 1:
			{
			poloha=50;
			smer =0; 
			poloha++;
			if (poloha==maximum) smer = 0;	//zmena smeru pohybu serva
			break;
			}
		}

		servo_poloha(poloha, 3);	//zmena polohy serva
		
		//vypsani polohy serva na displej
		lcd_gotoxy(0,1);	//nastaveni kurzoru na pozici x, y
		if (poloha<100)
			{
			if (poloha<10)
				{
				sprintf(string,"poloha3=00%u",poloha);
				}
				else sprintf(string,"poloha3=0%u",poloha);
			}
		else sprintf(string,"poloha3=%u",poloha);
		lcd_puts(string);	//vypsani textu na LCD
	}		
	//konec zmeny polohy serva
	
	}
}


/*
** Konec zdrojovho souboru
*/
