/*
** ===================================================================
** Nzev souboru   : servo.c
** Mikrokontroler  : ATmega16
** Popis           : Hlavickovy soubor pro ovldn modelskho serva
**
** Autor           : Radek Balada ( xbalad01@stud.feec.vutbr.cz )
** Pedmt         : Mikropocitace pro pristrojove aplikace
** ===================================================================
*/

#ifndef _SERVO_H
//#define _SERVO_H 1

/*
** ===================================================================
** Konstanty
** ===================================================================
*/
#define SERVO_PORT		PORTB			// vstupn port pro ovladani serva
#define DDR( x )		( *(&x - 1) )	// adresa smrovho registru portu

#define PIN_OUT0 0						// Definice pinu OUTPUT 0
#define PIN_OUT1 1						// Definice pinu OUTPUT 1
#define PIN_OUT2 2						// Definice pinu OUTPUT 2
#define PIN_OUT3 3						// Definice pinu OUTPUT 3
#define PIN_OUT4 4						// Definice pinu OUTPUT 4
#define PIN_OUT5 5						// Definice pinu OUTPUT 5
#define PIN_OUT6 6						// Definice pinu OUTPUT 6
#define PIN_OUT7 7						// Definice pinu OUTPUT 7

/* Ovladani OUTPUT 0 */
#define output0low 	SERVO_PORT=SERVO_PORT | (1<<PIN_OUT0)
#define output0hi 	SERVO_PORT=SERVO_PORT & (0xFF-(1<<PIN_OUT0))
/* Ovladani OUTPUT 1 */
#define output1low 	SERVO_PORT=SERVO_PORT | (1<<PIN_OUT1)
#define output1hi 	SERVO_PORT=SERVO_PORT & (0xFF-(1<<PIN_OUT1))
/* Ovladani OUTPUT 2 */
#define output2low 	SERVO_PORT=SERVO_PORT | (1<<PIN_OUT2)
#define output2hi 	SERVO_PORT=SERVO_PORT & (0xFF-(1<<PIN_OUT2))
/* Ovladani OUTPUT 3 */
#define output3low 	SERVO_PORT=SERVO_PORT | (1<<PIN_OUT3)
#define output3hi	SERVO_PORT=SERVO_PORT & (0xFF-(1<<PIN_OUT3))
/* Ovladani OUTPUT 4 */
#define output4low 	SERVO_PORT=SERVO_PORT | (1<<PIN_OUT4)
#define output4hi	SERVO_PORT=SERVO_PORT & (0xFF-(1<<PIN_OUT4))
/* Ovladani OUTPUT 5 */
#define output5low 	SERVO_PORT=SERVO_PORT | (1<<PIN_OUT5)
#define output5hi 	SERVO_PORT=SERVO_PORT & (0xFF-(1<<PIN_OUT5))
/* Ovladani OUTPUT 6 */
#define output6low 	SERVO_PORT=SERVO_PORT | (1<<PIN_OUT6)
#define output6hi	SERVO_PORT=SERVO_PORT & (0xFF-(1<<PIN_OUT6))
/* Ovladani OUTPUT 7 */
#define output7low 	SERVO_PORT=SERVO_PORT | (1<<PIN_OUT7)
#define output7hi 	SERVO_PORT=SERVO_PORT & (0xFF-(1<<PIN_OUT7))




/*
** ===================================================================
** Prototypy funkc
** ===================================================================
*/
void servo_init( char temp );					// inicializace serva
void servo_poloha( char temp2, char temp3 ); 	// zmena polohy serva


#endif
/*
** ===================================================================
** Konec hlavikovho souboru
** ===================================================================
*/
