/*
** ===================================================================
** Nzev souboru   : servo.c
** Mikrokontroler  : ATmega16
** Popis           : Funkce pro ovldn modelskho serva
**
** Autor           : Radek Balada ( xbalad01@stud.feec.vutbr.cz )
** Pedmt         : Mikroprocesorov technika
** Posledn zmna  : 29.08.06 15:05
** ===================================================================
*/


/*
** Hlavikov soubory
*/
#include <stdio.h> 		// definin soubor pro mikrokontrolr ATmega16
#include ".\avr\interrupt.h" //definicni soubor pro obsluhu preruseni
#define F_CPU 16000000		//definice frekvence procesoru
#include <util/delay.h>		//definicni soubor pro zpozdeni
#include "lcd_h.h" 


/*
** Globln promnn
*/
char maximum=0b11101111;
char neutral=0b11100111;
char minimum=0b11011111;
char poloha= 0b11100111;
int	 stav=0;
char string[16];
int pocet=0;

	
/*
** ===================================================================
**     Nzev funkce  : main()
**
**     Popis         :
**         Inicializace mikrokontroleru, vypsani textu na LCD displej,
**		   nastaveni stredove polohy serva
**     Parametry     : dn
**     Vst. hodnota : dn
** ===================================================================
*/
int main()
{
// Inicializaceregistru pro PWM citace/casovace 0 
DDRB=0xff; // nastavi portB jako vystupni
TCCR0= (1<<WGM00)|(1<<WGM01)|(1<<COM01)|(1<<CS02)|(1<<CS00);	//nastaveni FAST PWM
OCR0=poloha;		//nastaveni stredove polohy serva


// Inicializace registru citace/casovace 2 pro zpozdeni
TCCR2= (1<<WGM20)|(1<<WGM21)|(1<<COM21)|(0<<COM20)|(1<<CS22)|(1<<CS21)|(1<<CS20);
OCR2=0b11110000;
TIMSK=(1<<TOIE2);
//konec zpozdeni



lcd_init();			//inicializace displeje 
lcd_clrscr();		//smazani displeje
lcd_gotoxy(0,0);	//nastaveni kurzoru na pozici x, y
lcd_puts("Rizeni serva");	//vypsani textu na LCD
lcd_gotoxy(0,1);	//nastaveni kurzoru na pozici x, y
sprintf(string,"poloha=%u",poloha);
lcd_puts(string);	//vypsani textu na LCD

//lcd_clrscr();


sei();				//globalni povoleni preruseni
while(1)		//nekonecna smycka
	{
	
	}
}



/*
** ===================================================================
**     Nzev funkce  : ISR( TIMER2_OVF_vect )
**
**     Popis         :
**         Obsluha preruseni citace/casovace 2, krokovani polohy serva
**			stridave z jedne krajni polohy do druhe
** ===================================================================
*/
ISR( TIMER2_OVF_vect )
{
	if (pocet==2)
	{
			if (stav==0)
			{
			if (poloha < maximum)
			{
				poloha++;
				OCR0=poloha;
			}
			else stav=1;
			}
			if (stav==1)
			{
			if (poloha > minimum)
			{
				poloha--;
				OCR0=poloha;
			}
			else stav=0;
			}
		
			lcd_gotoxy(0,1);
			sprintf(string,"poloha=%u",poloha);
			lcd_puts(string);
		

		pocet=0;
	}
pocet++;
}


/*
** Konec zdrojovho souboru
*/
